:root {
	--primary-color: 							#0d6efd;
	--primary-color-light: 				#2c80ff;
	--danger-color: 							#dc3545;
	--danger-color-light: 				#e2969e;
	--text-color: 								#212529;
	--form-border-color: 					#dee2e6;
	--form-background-color: 			#f5f6f8;
	--form-item-border-color: 		#c1c7cc;
	--form-item-background-color: #ccd3da;
	--black: 											#000;
	--white: 											#fff;
	--grey:												rgb(223, 223, 223);

	--progressbar-progress-color: #ffc107;
	--progressbar-color-chrome: linear-gradient(to right, #ffc107 0%, #ffc107 50%, #c1c7cc 50%, #c1c7cc 100%);
}

* {
	margin: 0;
	padding: 0;
	font-family: Arial, Helvetica, sans-serif;
}

/* Remove focus and invalid border from input fields */
input:focus, input:invalid {
	outline: none;
	box-shadow: none;
}

/* General layout */
#wrapper {
	width: 100vw;
	height: 100vh;
	display: flex;
	align-items: center;
	justify-content: center;
}

#app {
	width: 80vh;
	height: 80vh;
	display: flex;
	flex-direction: column;
	align-items: center;
	justify-content: space-around;
}

#labyrinth {
	width: 80%;
	height: 80%;
	border: 1px solid var(--primary-color);
}

#labyrinth > h1 {
	text-align: center;
	color: var(--text-color);
}

#control {
	display: flex;
	width: 80%;
	margin-top: 10px;
	padding: 10px 0;
}

#fields {
	display: flex;
	flex-direction: column;
	flex: 3;
}

#button-container-submit {
	flex: 1;
	align-items: center;
	justify-content: center;
}

#inputs {
	display: flex;
	flex-direction: row;
}

#inputs > .form-field {
	flex: 1;
}

#ranges > legend {
	display: flex;
	align-items: center;
	justify-content: space-between;
	font-size: 0.8em;
}

#errors {
	position: absolute;
	width: 100%;
}

#table-labyrinth {
	width: 100%;
	height: 100%;
	border-collapse: collapse;
}

/* Reusable classes */

.form-container {
	border: 1px solid var(--form-border-color);
	border-radius: 5px;
	background: var(--form-background-color);
}

.form-field  {
	display: flex;
	flex-direction: column;
	margin: 10px;
}

.form-field > input:not(input[type=range]) {
	color: var(--text-color);
	border: 1px solid var(--form-item-border-color);
	padding: 5px;
	font-size: 1em;
	background: var(--form-item-background-color);
	border-radius: 3px;
}

.form-field > label {
	color: var(--text-color);
	font-size: 0.9em;
	margin: 0 0 3px 5px;
}

.button-container {
	display: flex;
	align-items: center;
}

.button-container > button {
	background: var(--primary-color-light);
	border: none;
	color: var(--white);
	padding: 10px;
	border-radius: 3px;
	cursor: pointer;
	transition: .2s ease-in-out;
}

.button-container > button:hover {
	background: var(--primary-color);
}

.alert {
	margin: 10px;
	border-radius: 3px;
	background: var(--danger-color);
	padding: 10px;
	color: var(--white);
}

.d-none {
	display: none;
}

.error {
	border-color: var(--danger-color) !important;
	background-color: var(--danger-color-light) !important;
}

.border-dark   {
	border: 1px solid var(--text-color) !important;
	border-radius: 3px;
}

.centered {
	display: flex;
	align-items: center;
	justify-content: center;
}

td {
	text-align: center;
}

td.tile-not-walkable { 
	/*background: black; */
	background: var(--primary-color);
	color: white;
}

td.tile-walkable { 
	/*background: violet;*/
	background: var(--grey);
	color: black;
}

td {
	border: 1px solid white;
}

/* Change border color in labyrinth (not white borders for tiles which represent the border of the labyrinth) */
tr:first-of-type td.tile-walkable {
	border-top-color: var(--grey);
}

tr:last-of-type td.tile-walkable {
	border-bottom-color: var(--grey);
}

tr:first-of-type td.tile-not-walkable {
	border-top-color: var(--primary-color);
}

tr:last-of-type td.tile-not-walkable {
	border-bottom-color: var(--primary-color);
}

tr > td.tile-walkable:first-of-type {
	border-left-color: var(--grey);
}

tr > td.tile-not-walkable:first-of-type {
	border-left-color: var(--primary-color-light);
}

tr > td.tile-walkable:last-of-type {
	border-right-color: var(--grey);
}

tr > td.tile-not-walkable:last-of-type {
	border-right-color: var(--primary-color-light);
}

/* Media query for smartphones */
@media (max-width: 576px) {
	#control {
		flex-direction: column;
	}

	#inputs {
		flex-direction: column;
	}

	#button-container-submit {
		justify-content: flex-start;
		margin: 10px 0 10px 20px;
	}
}